Require Import Coq.Lists.List.
Import ListNotations.
Require Import Program.
Require Import ProgramCalculation.library.Notations.
Require Import ProgramCalculation.library.Tactics.
Require Import ProgramCalculation.theories.Lists.Notations.
Require Import ProgramCalculation.library.FunctionalExtensionalEq.
Generalizable All Variables.

Lemma map_distributivity (A B C:Type)(f:B -> C)(g:A -> B):
    (f ∘ g)✶ =phi= f✶ ∘ g✶.
  Begin.
    intro l. induction l as [ | a l IHl ].
    - LHS 
      = { trivial }
      ( (f✶ ∘ g✶) [] ).
      □. 
    - RHS 
      = { by def compose }
      ( f✶ (g✶ (a::l)) ).
      = { by def map }
      ( (f(g a))::(f✶ (g✶ l)) ).
      = { by def compose }
      ( (f(g a))::((f✶ ∘g✶) l) ).
      = { rewrite IHl }
      ( (f(g a))::(f ∘ g)✶ l ).
      = { by def map }
      LHS. 
      □.
  Qed.